/**
 * Created by jie on 2017/10/11.
 */
var winston = require('winston');
require('winston-daily-rotate-file');
var path = require('path');
var fs = require('fs')

function logFileName(filepath,username,type) {
    var dirpath=path.join(filepath , type);
    if(!fs.existsSync(dirpath))
    {
        fs.mkdirSync(dirpath);
    }
    return path.join(filepath , type , username + '.log');
}

var Filelog = exports.filelog = function (options) {
    if(options){
        this.option={
            level:'debug',
            name:'log',
            datePattern: options.datePattern || 'yyyy-MM-dd',
            filename:logFileName(options.filepath,'log','log'),
            prepend:false,
            localTime:options.localTime || false,
            zippedArchive:false,
            maxDays:options.maxDays|| 0
        };
    }
    else {
        throw "Parameter incomplete";
    }
    this.infoTransport = new (winston.transports.DailyRotateFile)(this.option);
    this.logger = new (winston.Logger)({
        transports: [
            this.infoTransport
        ],
        /*exceptionHandlers: [
            new winston.transports.File({ filename: 'exceptions.log' })
        ],*/
        exitOnError: false
    });
};

//
// ### function logInfo
// #### @message {string} json to log into db
//
Filelog.prototype.logInfo=function(message,callback){
    //console.log("logInfo");
    try{
        this.logger.info(message);
        callback(null,{
            msgcode:'200',
            msg:'ok'
        });
    }
    catch (err){
        callback(err,{
            msgcode:'201',
            msg:'fail'
        });
    }
};

//
// ### function logDebug
// #### @message {string} json to log into db
//
Filelog.prototype.logDebug=function(message,callback){
    //console.log("logDebug");
    try{
        this.logger.debug(message);
        callback(null,{
            msgcode:'200',
            msg:'ok'
        });
    }
    catch (err){
        callback(err,{
            msgcode:'201',
            msg:'fail'
        });
    }
};

//
// ### function logError
// #### @message {string} json to log into db
//
Filelog.prototype.logError=function(message,callback){
    //console.log("logError");
    try{
        this.logger.error(message);
        callback(null,{
            msgcode:'200',
            msg:'ok'
        });
    }
    catch (err){
        callback(err,{
            msgcode:'201',
            msg:'fail'
        });
    }
};




