/**
 * Created by jie on 2017/10/11.
 */
var config = require('./config.js');
var winston = require('winston');
require('winston-mongodb');

var Mongodblog = exports.mongodblog = function (options) {
    try {
        this.option = config.mongodb;
        if (options) {
            if (options.db) this.option.db = options.db;
            if (options.collection) this.option.collection = options.collection;
            if (options.username) this.option.username = options.username;
            if (options.password) this.option.password = options.password;
            if (options.option) this.option.options = options.option;
        }
        else {
            throw "Parameter incomplete";
        }
        this.transport = new (winston.transports.MongoDB)(this.option);
        this.logger = new (winston.Logger)({
            transports: [
                this.transport
            ],
             /*exceptionHandlers: [
                 new winston.transports.File({ filename: 'exceptions.log' })
             ],*/
            exitOnError: false
        });
    }
    catch (err) {
        throw "Parameter incomplete";
    }
};

//
// ### function logInfo
// #### @message {string} json to log into db
//
Mongodblog.prototype.logInfo = function (message, callback) {
    try {
        this.logger.info(message);
        if (typeof callback === 'function') {
            callback(null, {
                msgcode: '200',
                msg: 'ok'
            });
        }
    }
    catch (err) {
        if (typeof callback === 'function') {
            callback(err, {
                msgcode: '201',
                msg: 'fail'
            });
        }
    }
};

//
// ### function logDebug
// #### @message {string} json to log into db
//
Mongodblog.prototype.logDebug = function (message, callback) {
    try {
        this.logger.debug(message);
        if (typeof callback === 'function') {
            callback(null, {
                msgcode: '200',
                msg: 'ok'
            });
        }
    }
    catch (err) {
        if (typeof callback === 'function') {
            callback(err, {
                msgcode: '201',
                msg: 'fail'
            });
        }
    }
};

//
// ### function logError
// #### @message {string} json to log into db
//
Mongodblog.prototype.logError = function (message, callback) {
    try {
        this.logger.error(message);
        if (typeof callback === 'function') {
            callback(null, {
                msgcode: '200',
                msg: 'ok'
            });
        }
    }
    catch (err) {
        if (typeof callback === 'function') {
            callback(err, {
                msgcode: '201',
                msg: 'fail'
            });
        }

    }
};

